#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

// 
//

#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1  Black
#property indicator_color2  Blue
#property indicator_color3  Black

//
//
//
//
//

extern string TimeFrame     = "Current time frame";
extern double MAPeriod      = 3;
extern double up_shift      = 0.0;
extern double ma_shift      = 0.0;
extern double dn_shift      = 0.0;
extern int    ma_method     = MODE_EMA;
extern int    applied_price = PRICE_TYPICAL;
extern bool   Interpolate   = false;

//
//
//
//
//

double up[];
double md[];
double dn[];
double sup[];
double res[];

//
//
//
//
//

string indicatorFileName;
bool   calculateValue;
bool   returnBars;
int    timeFrame;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{

   IndicatorBuffers(5);
   SetIndexBuffer(0,up);
   SetIndexBuffer(1,md);
   SetIndexBuffer(2,dn);
   SetIndexBuffer(3,res);
   SetIndexBuffer(4,sup);

      //
      //
      //
      //
      //
   
         indicatorFileName = WindowExpertName();
         calculateValue    = TimeFrame=="calculateValue"; if (calculateValue) { return(0); }
         returnBars        = TimeFrame=="returnBars";     if (returnBars)     { return(0); }
         timeFrame         = stringToTimeFrame(TimeFrame);
         SetIndexShift(0,up_shift * timeFrame/Period());  
         SetIndexShift(1,ma_shift * timeFrame/Period());  
         SetIndexShift(2,dn_shift * timeFrame/Period());  
   
      //
      //
      //
      //
      // 
       
     
     IndicatorShortName(timeFrameToString(timeFrame)+"  DG ("+DoubleToStr(MAPeriod,2)+")");
     
return(0);
}

int deinit() {  return(0);}

//
//
//
//                           
//
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;
   
   if(counted_bars < 0) return(-1);
   if(counted_bars > 0) counted_bars--;
           limit = MathMin(Bars-counted_bars,Bars-1);
           if (returnBars) { up[0] = MathMin(limit+1,Bars-1); return(0); }

   //
   //
   //
   //
   //


   if (calculateValue || timeFrame==Period())
   { 
     for (i=limit; i>=0; i--) sup[i] = (((iHigh(NULL,0,i)+iLow(NULL,0,i)+iClose(NULL,0,i))*2)/3)-iHigh(NULL,0,i);
     for (i=limit; i>=0; i--) res[i] = (((iHigh(NULL,0,i)+iLow(NULL,0,i)+iClose(NULL,0,i))*2)/3)-iLow(NULL,0,i);
     for (i=limit; i>=0; i--)
     {
        up[i] = iMAOnArray(res,0,3, up_shift,ma_method,i);
        md[i] = iMA(NULL,0,MAPeriod,ma_shift,ma_method,applied_price,i);
        dn[i] = iMAOnArray(sup,0,3, dn_shift,ma_method,i);

     }
     return(0);
     }
     
    //
    //
    //
    //
    //

    limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
    for (i=limit; i>=0; i--)
    {
       int y = iBarShift(NULL,timeFrame,Time[i]);
          up[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",MAPeriod,up_shift,ma_shift,dn_shift,ma_method,applied_price,0,y);
          md[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",MAPeriod,up_shift,ma_shift,dn_shift,ma_method,applied_price,1,y);
          dn[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",MAPeriod,up_shift,ma_shift,dn_shift,ma_method,applied_price,2,y);
          
          //
          //
          //
          //
          //
      
          if (!Interpolate || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;

          //
          //
          //
          //
          //

          datetime time = iTime(NULL,timeFrame,y);
             for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
             for(int k = 1; k < n; k++)
             {
                up[i+k] = up[i] + (up[i+n] - up[i]) * k/n;
                md[i+k] = md[i] + (md[i+n] - md[i]) * k/n;
                dn[i+k] = dn[i] + (dn[i+n] - dn[i]) * k/n;
                 
             }                  
     }
      
return(0);
}

//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}
  